diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc ns-3.41/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc
--- ns-3.40/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2024-02-09 14:44:08.497794400 -0800
@@ -111,45 +111,114 @@
     m_channelModel->GetAttribute(name, value);
 }
 
-PhasedArrayModel::ComplexVector
+Ptr<const MatrixBasedChannelModel::Complex3DVector>
 ThreeGppSpectrumPropagationLossModel::CalcLongTerm(
     Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
-    const PhasedArrayModel::ComplexVector& sW,
-    const PhasedArrayModel::ComplexVector& uW) const
+    Ptr<const PhasedArrayModel> sAnt,
+    Ptr<const PhasedArrayModel> uAnt) const
 {
     NS_LOG_FUNCTION(this);
 
-    size_t uAntennaNum = uW.GetSize();
-    size_t sAntennaNum = sW.GetSize();
+    const PhasedArrayModel::ComplexVector& sW = sAnt->GetBeamformingVectorRef();
+    const PhasedArrayModel::ComplexVector& uW = uAnt->GetBeamformingVectorRef();
+    size_t sAntNumElems = sW.GetSize();
+    size_t uAntNumElems = uW.GetSize();
+    NS_ASSERT(uAntNumElems == params->m_channel.GetNumRows());
+    NS_ASSERT(sAntNumElems == params->m_channel.GetNumCols());
+    NS_LOG_DEBUG("CalcLongTerm with " << uW.GetSize() << " u antenna elements and " << sW.GetSize()
+                                      << " s antenna elements, and with "
+                                      << " s ports: " << sAnt->GetNumPorts()
+                                      << " u ports: " << uAnt->GetNumPorts());
+    NS_ASSERT_MSG((sAnt != nullptr) && (uAnt != nullptr), "Improper call to the method");
+    size_t numClusters = params->m_channel.GetNumPages();
+    // create and initialize the size of the longTerm 3D matrix
+    Ptr<MatrixBasedChannelModel::Complex3DVector> longTerm =
+        Create<MatrixBasedChannelModel::Complex3DVector>(uAnt->GetNumPorts(),
+                                                         sAnt->GetNumPorts(),
+                                                         numClusters);
+    // Calculate long term uW * Husn * sW, the result is a matrix
+    // with the dimensions #uPorts, #sPorts, #cluster
+    for (auto sPortIdx = 0; sPortIdx < sAnt->GetNumPorts(); sPortIdx++)
+    {
+        for (auto uPortIdx = 0; uPortIdx < uAnt->GetNumPorts(); uPortIdx++)
+        {
+            for (size_t cIndex = 0; cIndex < numClusters; cIndex++)
+            {
+                longTerm->Elem(uPortIdx, sPortIdx, cIndex) =
+                    CalculateLongTermComponent(params, sAnt, uAnt, sPortIdx, uPortIdx, cIndex);
+            }
+        }
+    }
+    return longTerm;
+}
 
-    NS_ASSERT(uAntennaNum == params->m_channel.GetNumRows());
-    NS_ASSERT(sAntennaNum == params->m_channel.GetNumCols());
+std::complex<double>
+ThreeGppSpectrumPropagationLossModel::CalculateLongTermComponent(
+    Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
+    Ptr<const PhasedArrayModel> sAnt,
+    Ptr<const PhasedArrayModel> uAnt,
+    uint16_t sPortIdx,
+    uint16_t uPortIdx,
+    uint16_t cIndex) const
+{
+    NS_LOG_FUNCTION(this);
+    const PhasedArrayModel::ComplexVector& sW = sAnt->GetBeamformingVectorRef();
+    const PhasedArrayModel::ComplexVector& uW = uAnt->GetBeamformingVectorRef();
+    auto sPortElems = sAnt->GetNumElemsPerPort();
+    auto uPortElems = uAnt->GetNumElemsPerPort();
+    auto startS = sAnt->ArrayIndexFromPortIndex(sPortIdx, 0);
+    auto startU = uAnt->ArrayIndexFromPortIndex(uPortIdx, 0);
+    std::complex<double> txSum(0, 0);
+    // limiting multiplication operations to the port location
+    auto sIndex = startS;
+    // The sub-array partition model is adopted for TXRU virtualization,
+    // as described in Section 5.2.2 of 3GPP TR 36.897,
+    // and so equal beam weights are used for all the ports.
+    // Support of the full-connection model for TXRU virtualization would need extensions.
+    for (size_t tIndex = 0; tIndex < sPortElems; tIndex++, sIndex++)
+    {
+        std::complex<double> rxSum(0, 0);
+        auto uIndex = startU;
+        for (size_t rIndex = 0; rIndex < uPortElems; rIndex++, uIndex++)
+        {
+            rxSum += uW[uIndex - startU] * params->m_channel(uIndex, sIndex, cIndex);
+            auto testV = (rIndex % uAnt->GetHElemsPerPort());
+            auto ptInc = uAnt->GetHElemsPerPort() - 1;
+            if (testV == ptInc)
+            {
+                auto incVal = uAnt->GetNumColumns() - uAnt->GetHElemsPerPort();
+                uIndex += incVal; // Increment by a factor to reach next column in a port
+            }
+        }
 
-    NS_LOG_DEBUG("CalcLongTerm with " << uAntennaNum << " u antenna elements and " << sAntennaNum
-                                      << " s antenna elements.");
-    // store the long term part to reduce computation load
-    // only the small scale fading needs to be updated if the large scale parameters and antenna
-    // weights remain unchanged. here we calculate long term uW * Husn * sW, the result is an array
-    // of values per cluster
-    return params->m_channel.MultiplyByLeftAndRightMatrix(uW.Transpose(), sW);
+        txSum += sW[sIndex - startS] * rxSum;
+        auto testV = (tIndex % sAnt->GetHElemsPerPort());
+        auto ptInc = sAnt->GetHElemsPerPort() - 1;
+        if (testV == ptInc)
+        {
+            size_t incVal = sAnt->GetNumColumns() - sAnt->GetHElemsPerPort();
+            sIndex += incVal; // Increment by a factor to reach next column in a port
+        }
+    }
+    return txSum;
 }
 
-Ptr<SpectrumValue>
+Ptr<SpectrumSignalParameters>
 ThreeGppSpectrumPropagationLossModel::CalcBeamformingGain(
-    Ptr<SpectrumValue> txPsd,
-    PhasedArrayModel::ComplexVector longTerm,
+    Ptr<const SpectrumSignalParameters> params,
+    Ptr<const MatrixBasedChannelModel::Complex3DVector> longTerm,
     Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
     Ptr<const MatrixBasedChannelModel::ChannelParams> channelParams,
-    const ns3::Vector& sSpeed,
-    const ns3::Vector& uSpeed) const
+    const Vector& sSpeed,
+    const ns3::Vector& uSpeed,
+    uint8_t numTxPorts,
+    uint8_t numRxPorts,
+    bool isReverse) const
+
 {
     NS_LOG_FUNCTION(this);
-
-    Ptr<SpectrumValue> tempPsd = Copy<SpectrumValue>(txPsd);
-
-    // channel[cluster][rx][tx]
-    uint16_t numCluster = channelMatrix->m_channel.GetNumPages();
-
+    Ptr<SpectrumSignalParameters> rxParams = params->Copy();
+    size_t numCluster = channelMatrix->m_channel.GetNumPages();
     // compute the doppler term
     // NOTE the update of Doppler is simplified by only taking the center angle of
     // each cluster in to consideration.
@@ -157,18 +226,15 @@
     double factor = 2 * M_PI * slotTime * GetFrequency() / 3e8;
     PhasedArrayModel::ComplexVector doppler(numCluster);
 
-    // The following asserts might seem paranoic, but it is important to
-    // make sure that all the structures that are passed to this function
+    // Make sure that all the structures that are passed to this function
     // are of the correct dimensions before using the operator [].
-    // If you dont understand the comment read about the difference of .at()
-    // and [] operators, ...
     NS_ASSERT(numCluster <= channelParams->m_alpha.size());
     NS_ASSERT(numCluster <= channelParams->m_D.size());
     NS_ASSERT(numCluster <= channelParams->m_angle[MatrixBasedChannelModel::ZOA_INDEX].size());
     NS_ASSERT(numCluster <= channelParams->m_angle[MatrixBasedChannelModel::ZOD_INDEX].size());
     NS_ASSERT(numCluster <= channelParams->m_angle[MatrixBasedChannelModel::AOA_INDEX].size());
     NS_ASSERT(numCluster <= channelParams->m_angle[MatrixBasedChannelModel::AOD_INDEX].size());
-    NS_ASSERT(numCluster <= longTerm.GetSize());
+    NS_ASSERT(numCluster <= longTerm->GetNumPages());
 
     // check if channelParams structure is generated in direction s-to-u or u-to-s
     bool isSameDirection = (channelParams->m_nodeIds == channelMatrix->m_nodeIds);
@@ -179,7 +245,7 @@
     MatrixBasedChannelModel::DoubleVector aod;
 
     // if channel params is generated in the same direction in which we
-    // generate the channel matrix, angles and zenith od departure and arrival are ok,
+    // generate the channel matrix, angles and zenith of departure and arrival are ok,
     // just set them to corresponding variable that will be used for the generation
     // of channel matrix, otherwise we need to flip angles and zeniths of departure and arrival
     if (isSameDirection)
@@ -197,7 +263,7 @@
         aoa = channelParams->m_angle[MatrixBasedChannelModel::AOD_INDEX];
     }
 
-    for (uint16_t cIndex = 0; cIndex < numCluster; cIndex++)
+    for (size_t cIndex = 0; cIndex < numCluster; cIndex++)
     {
         // Compute alpha and D as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3
         // These terms account for an additional Doppler contribution due to the
@@ -227,44 +293,139 @@
 
     NS_ASSERT(numCluster <= doppler.GetSize());
 
-    // apply the doppler term and the propagation delay to the long term component
-    // to obtain the beamforming gain
-    auto vit = tempPsd->ValuesBegin();      // psd iterator
-    auto sbit = tempPsd->ConstBandsBegin(); // band iterator
-    while (vit != tempPsd->ValuesEnd())
+    // set the channel matrix
+    rxParams->spectrumChannelMatrix = GenSpectrumChannelMatrix(rxParams->psd,
+                                                               longTerm,
+                                                               channelMatrix,
+                                                               channelParams,
+                                                               doppler,
+                                                               numTxPorts,
+                                                               numRxPorts,
+                                                               isReverse);
+
+    // The precoding matrix is not set
+    if (!rxParams->precodingMatrix)
+    {
+        // Update rxParams->Psd.
+        // Compute RX PSD from the channel matrix
+        auto vit = rxParams->psd->ValuesBegin(); // psd iterator
+        size_t rbIdx = 0;
+        while (vit != rxParams->psd->ValuesEnd())
+        {
+            // Calculate PSD for the first antenna port (correct for SISO)
+            *vit = std::norm(rxParams->spectrumChannelMatrix->Elem(0, 0, rbIdx));
+            vit++;
+            rbIdx++;
+        }
+    }
+    else
+    {
+        NS_ASSERT_MSG(rxParams->psd->GetValuesN() == rxParams->spectrumChannelMatrix->GetNumPages(),
+                      "RX PSD and the spectrum channel matrix should have the same number of RBs ");
+        // Calculate RX PSD from the spectrum channel matrix, H and
+        // the precoding matrix, P as:
+        // PSD = (H*P)^h * (H*P),
+        // where the dimensions are:
+        // H (rxPorts,txPorts,numRbs) x P (txPorts,txStreams, numRbs) =
+        // HxP (rxPorts,txStreams, numRbs)
+        MatrixBasedChannelModel::Complex3DVector hP =
+            *rxParams->spectrumChannelMatrix * (*rxParams->precodingMatrix);
+        // (HxP)^h dimensions are (txStreams, rxPorts, numRbs)
+        MatrixBasedChannelModel::Complex3DVector hPHerm = hP.HermitianTranspose();
+
+        // Finally, (HxP)^h x (HxP) = PSD (txStreams, txStreams, numRbs)
+        MatrixBasedChannelModel::Complex3DVector psd = hPHerm * hP;
+        // Update rxParams->Psd
+        for (uint32_t rbIdx = 0; rbIdx < rxParams->psd->GetValuesN(); ++rbIdx)
+        {
+            (*rxParams->psd)[rbIdx] = 0.0;
+
+            for (size_t txStream = 0; txStream < psd.GetNumRows(); ++txStream)
+            {
+                (*rxParams->psd)[rbIdx] += std::real(psd(txStream, txStream, rbIdx));
+            }
+        }
+    }
+    return rxParams;
+}
+
+Ptr<MatrixBasedChannelModel::Complex3DVector>
+ThreeGppSpectrumPropagationLossModel::GenSpectrumChannelMatrix(
+    Ptr<SpectrumValue> inPsd,
+    Ptr<const MatrixBasedChannelModel::Complex3DVector> longTerm,
+    Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
+    Ptr<const MatrixBasedChannelModel::ChannelParams> channelParams,
+    PhasedArrayModel::ComplexVector doppler,
+    uint8_t numTxPorts,
+    uint8_t numRxPorts,
+    bool isReverse) const
+{
+    size_t numCluster = channelMatrix->m_channel.GetNumPages();
+    auto numRb = inPsd->GetValuesN();
+
+    auto directionalLongTerm = isReverse ? longTerm->Transpose() : (*longTerm);
+
+    Ptr<MatrixBasedChannelModel::Complex3DVector> chanSpct =
+        Create<MatrixBasedChannelModel::Complex3DVector>(numRxPorts, numTxPorts, (uint16_t)numRb);
+
+    // If "params" (ChannelMatrix) and longTerm were computed for the reverse direction (e.g. this
+    // is a DL transmission but params and longTerm were last updated during UL), then the elements
+    // in longTerm start from different offsets.
+
+    auto vit = inPsd->ValuesBegin();      // psd iterator
+    auto sbit = inPsd->ConstBandsBegin(); // band iterator
+    size_t iRb = 0;
+    // Compute the frequency-domain channel matrix
+    while (vit != inPsd->ValuesEnd())
     {
         if ((*vit) != 0.00)
         {
-            std::complex<double> subsbandGain(0.0, 0.0);
             double fsb = (*sbit).fc; // center frequency of the sub-band
-            for (uint16_t cIndex = 0; cIndex < numCluster; cIndex++)
+            for (auto rxPortIdx = 0; rxPortIdx < numRxPorts; rxPortIdx++)
             {
-                double delay = -2 * M_PI * fsb * (channelParams->m_delay[cIndex]);
-                subsbandGain = subsbandGain + longTerm[cIndex] * doppler[cIndex] *
-                                                  std::complex<double>(cos(delay), sin(delay));
+                for (auto txPortIdx = 0; txPortIdx < numTxPorts; txPortIdx++)
+                {
+                    std::complex<double> subsbandGain(0.0, 0.0);
+
+                    for (size_t cIndex = 0; cIndex < numCluster; cIndex++)
+                    {
+                        double delay = -2 * M_PI * fsb * (channelParams->m_delay[cIndex]);
+                        subsbandGain += directionalLongTerm(rxPortIdx, txPortIdx, cIndex) *
+                                        doppler[cIndex] *
+                                        std::complex<double>(cos(delay), sin(delay));
+                    }
+                    // Multiply with the square root of the input PSD so that the norm (absolute
+                    // value squared) of chanSpct will be the output PSD
+                    chanSpct->Elem(rxPortIdx, txPortIdx, iRb) = sqrt(*vit) * subsbandGain;
+                }
             }
-            *vit = (*vit) * (norm(subsbandGain));
         }
         vit++;
         sbit++;
+        iRb++;
     }
-    return tempPsd;
+    return chanSpct;
 }
 
-PhasedArrayModel::ComplexVector
+Ptr<const MatrixBasedChannelModel::Complex3DVector>
 ThreeGppSpectrumPropagationLossModel::GetLongTerm(
     Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
     Ptr<const PhasedArrayModel> aPhasedArrayModel,
     Ptr<const PhasedArrayModel> bPhasedArrayModel) const
 {
-    PhasedArrayModel::ComplexVector
+    Ptr<const MatrixBasedChannelModel::Complex3DVector>
         longTerm; // vector containing the long term component for each cluster
 
     // check if the channel matrix was generated considering a as the s-node and
     // b as the u-node or vice-versa
+    auto isReverse =
+        channelMatrix->IsReverse(aPhasedArrayModel->GetId(), bPhasedArrayModel->GetId());
+    auto sAntenna = isReverse ? bPhasedArrayModel : aPhasedArrayModel;
+    auto uAntenna = isReverse ? aPhasedArrayModel : bPhasedArrayModel;
+
     PhasedArrayModel::ComplexVector sW;
     PhasedArrayModel::ComplexVector uW;
-    if (!channelMatrix->IsReverse(aPhasedArrayModel->GetId(), bPhasedArrayModel->GetId()))
+    if (!isReverse)
     {
         sW = aPhasedArrayModel->GetBeamformingVector();
         uW = bPhasedArrayModel->GetBeamformingVector();
@@ -305,45 +466,41 @@
     {
         NS_LOG_DEBUG("compute the long term");
         // compute the long term component
-        longTerm = CalcLongTerm(channelMatrix, sW, uW);
-
-        // store the long term
+        longTerm = CalcLongTerm(channelMatrix, sAntenna, uAntenna);
         Ptr<LongTerm> longTermItem = Create<LongTerm>();
         longTermItem->m_longTerm = longTerm;
         longTermItem->m_channel = channelMatrix;
-        longTermItem->m_sW = sW;
-        longTermItem->m_uW = uW;
-
+        longTermItem->m_sW = std::move(sW);
+        longTermItem->m_uW = std::move(uW);
+        // store the long term to reduce computation load
+        // only the small scale fading needs to be updated if the large scale parameters and antenna
+        // weights remain unchanged.
         m_longTermMap[longTermId] = longTermItem;
     }
 
     return longTerm;
 }
 
-Ptr<SpectrumValue>
+Ptr<SpectrumSignalParameters>
 ThreeGppSpectrumPropagationLossModel::DoCalcRxPowerSpectralDensity(
-    Ptr<const SpectrumSignalParameters> params,
+    Ptr<const SpectrumSignalParameters> spectrumSignalParams,
     Ptr<const MobilityModel> a,
     Ptr<const MobilityModel> b,
     Ptr<const PhasedArrayModel> aPhasedArrayModel,
     Ptr<const PhasedArrayModel> bPhasedArrayModel) const
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << spectrumSignalParams << a << b << aPhasedArrayModel
+                         << bPhasedArrayModel);
+
+    if (a->GetPosition() == b->GetPosition())
+    {
+        return spectrumSignalParams->Copy();
+    }
     uint32_t aId = a->GetObject<Node>()->GetId(); // id of the node a
     uint32_t bId = b->GetObject<Node>()->GetId(); // id of the node b
-
-    NS_ASSERT(aId != bId);
-    NS_ASSERT_MSG(a->GetDistanceFrom(b) > 0.0,
-                  "The position of a and b devices cannot be the same");
-
-    Ptr<SpectrumValue> rxPsd = Copy<SpectrumValue>(params->psd);
-
-    // retrieve the antenna of device a
     NS_ASSERT_MSG(aPhasedArrayModel, "Antenna not found for node " << aId);
-    NS_LOG_DEBUG("a node " << a->GetObject<Node>() << " antenna " << aPhasedArrayModel);
-
-    // retrieve the antenna of the device b
-    NS_ASSERT_MSG(bPhasedArrayModel, "Antenna not found for device " << bId);
+    NS_LOG_DEBUG("a node " << aId << " antenna " << aPhasedArrayModel);
+    NS_ASSERT_MSG(bPhasedArrayModel, "Antenna not found for node " << bId);
     NS_LOG_DEBUG("b node " << bId << " antenna " << bPhasedArrayModel);
 
     Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix =
@@ -352,18 +509,28 @@
         m_channelModel->GetParams(a, b);
 
     // retrieve the long term component
-    PhasedArrayModel::ComplexVector longTerm =
+    Ptr<const MatrixBasedChannelModel::Complex3DVector> longTerm =
         GetLongTerm(channelMatrix, aPhasedArrayModel, bPhasedArrayModel);
 
+    auto isReverse =
+        channelMatrix->IsReverse(aPhasedArrayModel->GetId(), bPhasedArrayModel->GetId());
+
     // apply the beamforming gain
-    rxPsd = CalcBeamformingGain(rxPsd,
-                                longTerm,
-                                channelMatrix,
-                                channelParams,
-                                a->GetVelocity(),
-                                b->GetVelocity());
+    return CalcBeamformingGain(spectrumSignalParams,
+                               longTerm,
+                               channelMatrix,
+                               channelParams,
+                               a->GetVelocity(),
+                               b->GetVelocity(),
+                               aPhasedArrayModel->GetNumPorts(),
+                               bPhasedArrayModel->GetNumPorts(),
+                               isReverse);
+}
 
-    return rxPsd;
+int64_t
+ThreeGppSpectrumPropagationLossModel::DoAssignStreams(int64_t stream)
+{
+    return 0;
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h ns-3.41/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h
--- ns-3.40/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2024-02-09 14:44:08.497794400 -0800
@@ -30,6 +30,9 @@
 #include <map>
 #include <unordered_map>
 
+class ThreeGppCalcLongTermMultiPortTest;
+class ThreeGppMimoPolarizationTest;
+
 namespace ns3
 {
 
@@ -51,6 +54,9 @@
  */
 class ThreeGppSpectrumPropagationLossModel : public PhasedArraySpectrumPropagationLossModel
 {
+    friend class ::ThreeGppCalcLongTermMultiPortTest;
+    friend class ::ThreeGppMimoPolarizationTest;
+
   public:
     /**
      * Constructor
@@ -112,27 +118,27 @@
      * a certain channel is cached and recomputed only when the channel realization
      * is updated, or when the beamforming vectors change.
      *
-     * \param params tx parameters
+     * \param spectrumSignalParams spectrum signal tx parameters
      * \param a first node mobility model
      * \param b second node mobility model
      * \param aPhasedArrayModel the antenna array of the first node
      * \param bPhasedArrayModel the antenna array of the second node
      * \return the received PSD
      */
-    Ptr<SpectrumValue> DoCalcRxPowerSpectralDensity(
-        Ptr<const SpectrumSignalParameters> params,
+    Ptr<SpectrumSignalParameters> DoCalcRxPowerSpectralDensity(
+        Ptr<const SpectrumSignalParameters> spectrumSignalParams,
         Ptr<const MobilityModel> a,
         Ptr<const MobilityModel> b,
         Ptr<const PhasedArrayModel> aPhasedArrayModel,
         Ptr<const PhasedArrayModel> bPhasedArrayModel) const override;
 
-  private:
+  protected:
     /**
      * Data structure that stores the long term component for a tx-rx pair
      */
     struct LongTerm : public SimpleRefCount<LongTerm>
     {
-        PhasedArrayModel::ComplexVector
+        Ptr<const MatrixBasedChannelModel::Complex3DVector>
             m_longTerm; //!< vector containing the long term component for each cluster
         Ptr<const MatrixBasedChannelModel::ChannelMatrix>
             m_channel; //!< pointer to the channel matrix used to compute the long term
@@ -143,6 +149,28 @@
     };
 
     /**
+     * Computes the frequency-domain channel matrix with the dimensions numRxPorts*numTxPorts*numRBs
+     * \param inPsd the input PSD
+     * \param longTerm the long term component
+     * \param channelMatrix the channel matrix structure
+     * \param channelParams the channel parameters, including delays
+     * \param doppler the doppler for each cluster
+     * \param numTxPorts the number of antenna ports at the transmitter
+     * \param numRxPorts the number of antenna ports at the receiver
+     * \param isReverse true if params and longTerm were computed with RX->TX switched
+     * \return 3D spectrum channel matrix with dimensions numRxPorts * numTxPorts * numRBs
+     */
+    Ptr<MatrixBasedChannelModel::Complex3DVector> GenSpectrumChannelMatrix(
+        Ptr<SpectrumValue> inPsd,
+        Ptr<const MatrixBasedChannelModel::Complex3DVector> longTerm,
+        Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
+        Ptr<const MatrixBasedChannelModel::ChannelParams> channelParams,
+        PhasedArrayModel::ComplexVector doppler,
+        uint8_t numTxPorts,
+        uint8_t numRxPorts,
+        bool isReverse) const;
+
+    /**
      * Get the operating frequency
      * \return the operating frequency in Hz
      */
@@ -157,39 +185,66 @@
      * \param bPhasedArrayModel the antenna array of the rx device
      * \return vector containing the long term component for each cluster
      */
-    PhasedArrayModel::ComplexVector GetLongTerm(
+    Ptr<const MatrixBasedChannelModel::Complex3DVector> GetLongTerm(
         Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
         Ptr<const PhasedArrayModel> aPhasedArrayModel,
         Ptr<const PhasedArrayModel> bPhasedArrayModel) const;
     /**
      * Computes the long term component
      * \param channelMatrix the channel matrix H
-     * \param sW the beamforming vector of the s device
-     * \param uW the beamforming vector of the u device
+     * \param sAnt the pointer to the antenna of the s device
+     * \param uAnt the pointer to the antenna of the u device
      * \return the long term component
      */
-    PhasedArrayModel::ComplexVector CalcLongTerm(
+    Ptr<const MatrixBasedChannelModel::Complex3DVector> CalcLongTerm(
         Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
-        const PhasedArrayModel::ComplexVector& sW,
-        const PhasedArrayModel::ComplexVector& uW) const;
+        Ptr<const PhasedArrayModel> sAnt,
+        Ptr<const PhasedArrayModel> uAnt) const;
+
+    /**
+     * \brief Computes a longTerm component from a specific port of s device to the
+     * specific port of u device and for a specific cluster index
+     * \param params The params that include the channel matrix
+     * \param sAnt pointer to first antenna
+     * \param uAnt uAnt pointer to second antenna
+     * \param sPortIdx the port index of the s device
+     * \param uPortIdx the port index of the u device
+     * \param cIndex the cluster index
+     * \return longTerm component for port pair and for a specific cluster index
+     */
+    std::complex<double> CalculateLongTermComponent(
+        Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
+        Ptr<const PhasedArrayModel> sAnt,
+        Ptr<const PhasedArrayModel> uAnt,
+        uint16_t sPortIdx,
+        uint16_t uPortIdx,
+        uint16_t cIndex) const;
 
     /**
-     * Computes the beamforming gain and applies it to the tx PSD
-     * \param txPsd the tx PSD
+     * \brief Computes the beamforming gain and applies it to the TX PSD
+     * \param params SpectrumSignalParameters holding TX PSD
      * \param longTerm the long term component
-     * \param channelMatrix The channel matrix structure
-     * \param channelParams The channel params structure
-     * \param sSpeed speed of the first node
-     * \param uSpeed speed of the second node
-     * \return the rx PSD
-     */
-    Ptr<SpectrumValue> CalcBeamformingGain(
-        Ptr<SpectrumValue> txPsd,
-        PhasedArrayModel::ComplexVector longTerm,
+     * \param channelMatrix the channel matrix structure
+     * \param channelParams the channel params structure
+     * \param sSpeed the speed of the first node
+     * \param uSpeed the speed of the second node
+     * \param numTxPorts the number of the ports of the first node
+     * \param numRxPorts the number of the porst of the second node
+     * \param isReverse indicator that tells whether the channel matrix is reverse
+     * \return
+     */
+    Ptr<SpectrumSignalParameters> CalcBeamformingGain(
+        Ptr<const SpectrumSignalParameters> params,
+        Ptr<const MatrixBasedChannelModel::Complex3DVector> longTerm,
         Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
         Ptr<const MatrixBasedChannelModel::ChannelParams> channelParams,
         const Vector& sSpeed,
-        const Vector& uSpeed) const;
+        const Vector& uSpeed,
+        uint8_t numTxPorts,
+        uint8_t numRxPorts,
+        bool isReverse) const;
+
+    int64_t DoAssignStreams(int64_t stream) override;
 
     mutable std::unordered_map<uint64_t, Ptr<const LongTerm>>
         m_longTermMap;                           //!< map containing the long term components
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/trace-fading-loss-model.cc ns-3.41/src/spectrum/model/trace-fading-loss-model.cc
--- ns-3.40/src/spectrum/model/trace-fading-loss-model.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/trace-fading-loss-model.cc	2024-02-09 14:44:08.497794400 -0800
@@ -238,7 +238,7 @@
 }
 
 int64_t
-TraceFadingLossModel::AssignStreams(int64_t stream)
+TraceFadingLossModel::DoAssignStreams(int64_t stream)
 {
     NS_LOG_FUNCTION(this << stream);
     NS_ASSERT(m_streamsAssigned == false);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/trace-fading-loss-model.h ns-3.41/src/spectrum/model/trace-fading-loss-model.h
--- ns-3.40/src/spectrum/model/trace-fading-loss-model.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/trace-fading-loss-model.h	2024-02-09 14:44:08.497794400 -0800
@@ -58,15 +58,8 @@
      */
     typedef std::pair<Ptr<const MobilityModel>, Ptr<const MobilityModel>> ChannelRealizationId_t;
 
-    /**
-     * Assign a fixed random variable stream number to the random variables
-     * used by this model.  Return the number of streams (possibly zero) that
-     * have been assigned.
-     *
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this model
-     */
-    int64_t AssignStreams(int64_t stream);
+  protected:
+    int64_t DoAssignStreams(int64_t stream) override;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/tv-spectrum-transmitter.cc ns-3.41/src/spectrum/model/tv-spectrum-transmitter.cc
--- ns-3.40/src/spectrum/model/tv-spectrum-transmitter.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/tv-spectrum-transmitter.cc	2024-02-09 14:44:08.497794400 -0800
@@ -74,16 +74,17 @@
             .SetParent<SpectrumPhy>()
             .SetGroupName("Spectrum")
             .AddConstructor<TvSpectrumTransmitter>()
-            .AddAttribute("TvType",
-                          "The type of TV transmitter/modulation to be used.",
-                          EnumValue(TvSpectrumTransmitter::TVTYPE_8VSB),
-                          MakeEnumAccessor(&TvSpectrumTransmitter::m_tvType),
-                          MakeEnumChecker(TvSpectrumTransmitter::TVTYPE_8VSB,
-                                          "8vsb",
-                                          TvSpectrumTransmitter::TVTYPE_COFDM,
-                                          "cofdm",
-                                          TvSpectrumTransmitter::TVTYPE_ANALOG,
-                                          "analog"))
+            .AddAttribute(
+                "TvType",
+                "The type of TV transmitter/modulation to be used.",
+                EnumValue(TvSpectrumTransmitter::TVTYPE_8VSB),
+                MakeEnumAccessor<TvSpectrumTransmitter::TvType>(&TvSpectrumTransmitter::m_tvType),
+                MakeEnumChecker(TvSpectrumTransmitter::TVTYPE_8VSB,
+                                "8vsb",
+                                TvSpectrumTransmitter::TVTYPE_COFDM,
+                                "cofdm",
+                                TvSpectrumTransmitter::TVTYPE_ANALOG,
+                                "analog"))
             .AddAttribute("StartFrequency",
                           "The lower end frequency (in Hz) of the TV transmitter's "
                           "signal. Must be greater than or equal to 0.",
